# Real Madrid
- Pedro Augusto Tortola Pereira
- Gabriel Henrique Kwiatkovski Godinho
- Eric Yutaka Fukuyama  
Trabalho de Representação de Conhecimento em Lógica de Predicados  
Disciplina: Introdução a Lógica para a Computação  
Professor: Adolfo Gustavo Serra Seca Neto   
(DAINF - UTFPR Curitiba).  
# 1. Tema, Descrição do Tema e Integrantes da Equipe  
  Trabalho realizado pelos alunos Pedro Augusto Tortola Pereira, Gabriel Henrique Kwiatkovski Godinho e Eric Yutaka Fukuyama, sobre o time Real Madrid Club de Fútbol e seus jogadores. O trabalho tem como foco os jogadores da temporada 2018/2019 e o próprio time.  
# 2. Frases e Fórmulas
## 2.1 Propriedades de "objetos"  
|Frase|Courtois é um goleiro.|
|----|----|
|Fórmula|Goleiro("Courtois")|
|Definições de Predicados/Funções|Goleiro(X): X é um goleiro.| 

|Frase|Real Madrid é um time espanhol.|
|----|----|
|Fórmula|Time Espanhol("Real Madrid")|
|Definições de Predicados/Funções|Time Espanhol(X): X é um time espanhol.|

|Frase|Benzema é um atacante.|
|----|----|
|Fórmula|Atacante("Benzema")|
|Definições de Predicados/Funções|Atacante(X): X é um atacante.|

## 2.2 Relações entre "objetos"
|Frase|Barcelona e Real Madrid são rivais.|
|----|----|
|Fórmula|Rivais("Barcelona","Real Madrid")|
|Definições de Predicados/Funções|Rivais(X,Y): X e Y são rivais.|

|Frase|Casemiro e Marcelo são compatriotas.|
|----|----|
|Fórmula|Compatriotas("Casemiro","Marcelo")|
|Definições de Predicados/Funções|Compatriotas(X,Y): X e Y são compatriotas.|

|Frase|Zidane treina Casemiro e Navas.|
|----|----|
|Fórmula|Treina("Zidane","Casemiro","Navas")|
|Definições de Predicados/Funções|Treina(X,Y,Z): X treina Y e Z.|

|Frase|Sergio Ramos e Courtois jogam no Real Madrid.|
|----|----|
|Fórmula|Jogam("Sergio Ramos","Courtois")="Real Madrid"|
|Definições de Predicados/Funções|Jogam(X,Y):retorna a equipe em que X e Y jogam.|

## 2.3 Negações
|Frase|Marcelo não é um atacante.|
|----|----|
|Fórmula|¬Atacante("Marcelo")|
|Definições de Predicados/Funções||

|Frase|Sergio Ramos não é um goleiro.|
|----|----|
|Fórmula|¬Goleiro("Sergio Ramos")|
|Definições de Predicados/Funções||

## 2.4 Conjunções
|Frase|Marcelo é canhoto e um lateral esquerdo.|
|----|----|
|Fórmula|Canhoto("Marcelo") ^ Lateral-Esquerdo("Marcelo")|
|Definições de Predicados/Funções|Canhoto(X): X é canhoto.  Lateral-Esquerdo(X): X é um lateral esquerdo.|

|Frase|Sergio Ramos é um zagueiro e o capitão do Real Madrid.|
|----|----|
|Fórmula|Zagueiro("Sergio Ramos") ^ Capitão("Real Madrid")="Sergio Ramos"|
|Definições de Predicados/Funções|Zagueiro(X): X é um zagueiro.  Capitão(X): retorna o capitão do time X.|

## 2.5 Disjunções
|Frase|Real Madrid é o visitante ou o mandante.|
|----|----|
|Fórmula|Visitante("Real Madrid") V Mandante("Real Madrid")|
|Definições de Predicados/Funções|Visitante(X): X é o visitante em uma partida.  Mandante(X): X é o mandante em uma partida.|

|Frase|Casemiro é titular ou é reserva.|
|----|----|
|Fórmula|Titular("Casemiro") V Reserva("Casemiro")|
|Definições de Predicados/Funções|Titular(X): X é titular.  Reserva(X): X é reserva.|

## 2.6 Implicações

|Frase|Se Courtois é titular então Navas é reserva.|
|----|----|
|Fórmula|Titular("Courtois") → Reserva("Navas")|
|Definições de Predicados/Funções||

|Frase|Se Benzema é artilheiro então marca gols.|
|----|----|
|Fórmula|Artilheiro("Benzema") → Marca("Benzema")|
|Definições de Predicados/Funções|Artilheiro(X): X é artilheiro.  Marca(X): X marca gols.|

## 2.7 Generalizações Universais
|Frase|Todo artilheiro marca gols.|
|----|----|
|Fórmula|∀X(Artilheiro(X) → Marca(X))|
|Definições de Predicados/Funções||

|Frase|Todo capitão do Real Madrid é titular.|
|----|----|
|Fórmula|∀X(Capitão("Real Madrid")=X → Titular(X)|
|Definições de Predicados/Funções||

|Frase|Todo goleiro pode usar as mãos.|
|----|----|
|Fórmula|∀X(Goleiro(X) → Mãos(X))|
|Definições de Predicados/Funções|Mãos(X): X pode usar as mãos.|

## 2.8 Generalização Existenciais 
|Frase|Há ao menos um lateral esquerdo que assistiu Benzema.|
|----|----|
|Fórmula|∃Y(Lateral-Esquerdo(Y) → Assistir(Y,"Benzema"))|
|Definições de Predicados/Funções|Assistiu(X,Y): X assistiu Y.|

|Frase|Existe pelo menos um goleiro que foi campeão com Zidane.|
|----|----|
|Fórmula|∃Y(Goleiro(Y)^Campeão(Y,"Zidane"))|
|Definições de Predicados/Funções|Campeão(X,Y): X foi campeão com Y de técnico.|

|Frase|Há pelo menos um zagueiro que recebeu como punição o cartão vermelho.|
|----|----|
|Fórmula|∃Y(Zagueiro(Y)^Punição(Y)="Cartão Vermelho")|
|Definições de Predicados/Funções|Punição(X)=Y: retorna a maior punição que X recebeu em campo.|


## 3 Assinatura

  Σ = {R¹,R²,R³,C,F¹,F²,V}
  
 R¹ = {Goleiro, Time Espanhol, Atacante, Lateral Esquerdo, Canhoto, Zagueiro, Visitante, Mandante,Titular, Reserva, Artilheiro, Marca, Mãos}
 
 R² = {Compatriotas, Assistir, Campeão}
 
 R³ = {Treina} 
 
 C  = {"Courtois","Real Madrid", "Benzema", "Barcelona", "Casemiro", "Marcelo", "Zidane", "Sergio Ramos", "Cartão Vermelho", "Navas"}
 
 F¹ = {Capitão, Punição}
 
 F² = {Jogam}
 
 V  = {X,Y,Z}

## 4 Modelos

## 4.1 Exemplo de modelo que satisfaz todas as fórmulas(M<sub>1</sub>)
  
  1. Universo de valores concretos
       
       A={vc1, vc2, vc3, vc4, vc5, vc6, vc7, vc8, vc9, vc10, vc11, vc12, vc13, vc14}
  
  2. Constantes
    
      "Real Madrid"<sup>M<sub>1</sub></sup>=vc1
    
      "Barcelona"<sup>M<sub>1</sub></sup>=vc2
    
       "Zidane"<sup>M<sub>1</sub></sup>=vc3

       "Courtois"<sup>M<sub>1</sub></sup>=vc4
    
       "Navas"<sup>M<sub>1</sub></sup>=vc5

       "Benzema"<sup>M<sub>1</sub></sup>=vc6

       "Casemiro"<sup>M<sub>1</sub></sup>=vc7

       "Marcelo"<sup>M<sub>1</sub></sup>=vc8

       "Sergio Ramos"<sup>M<sub>1</sub></sup>=vc9

       "Messi"<sup>M<sub>1</sub></sup>=vc10

       "Cartão Vermelho"<sup>M<sub>1</sub></sup>=vc11

       "Cartão Amarelo"<sup>M<sub>1</sub></sup>=vc12

       "Ninguém"<sup>M<sub>1</sub></sup>=vc13

       "Nenhuma"<sup>M<sub>1</sub></sup>=vc14

  3. Funções
    
       Capitão<sup>M<sub>1</sub></sup>(vc1)=vc9

       Capitão<sup>M<sub>1</sub></sup>(vc2)=vc10

       Capitão<sup>M<sub>1</sub></sup>(...)=vc13

       Punição<sup>M<sub>1</sub></sup>(vc4)=vc12   

       Punição<sup>M<sub>1</sub></sup>(vc5)=vc12

       Punição<sup>M<sub>1</sub></sup>(vc6)=vc12

       Punição<sup>M<sub>1</sub></sup>(vc7)=vc11

       Punição<sup>M<sub>1</sub></sup>(vc8)=vc12

       Punição<sup>M<sub>1</sub></sup>(vc9)=vc11

       Punição<sup>M<sub>1</sub></sup>(vc10)=vc12

       Punição<sup>M<sub>1</sub></sup>(...)=vc14

       Jogam<sup>M<sub>1</sub></sup>(vc4,vc5)=vc1

       Jogam<sup>M<sub>1</sub></sup>(vc4,vc6)=vc1

       Jogam<sup>M<sub>1</sub></sup>(vc4,vc7)=vc1

       Jogam<sup>M<sub>1</sub></sup>(vc4,vc8)=vc1

       Jogam<sup>M<sub>1</sub></sup>(vc4,vc9)=vc1

       Jogam<sup>M<sub>1</sub></sup>(vc5,vc6)=vc1

       Jogam<sup>M<sub>1</sub></sup>(vc5,vc7)=vc1

       Jogam<sup>M<sub>1</sub></sup>(vc5,vc8)=vc1

       Jogam<sup>M<sub>1</sub></sup>(vc5,vc9)=vc1

       Jogam<sup>M<sub>1</sub></sup>(vc6,vc7)=vc1

       Jogam<sup>M<sub>1</sub></sup>(vc6,vc8)=vc1

       Jogam<sup>M<sub>1</sub></sup>(vc6,vc9)=vc1

       Jogam<sup>M<sub>1</sub></sup>(vc7,vc8)=vc1

       Jogam<sup>M<sub>1</sub></sup>(vc7,vc9)=vc1

       Jogam<sup>M<sub>1</sub></sup>(vc8,vc9)=vc1

       Jogam<sup>M<sub>1</sub></sup>(...,...)=vc14
   
   4. Predicados
    
       Goleiro<sup>M<sub>1</sub></sup>={vc4,vc5}

       Time Espanhol<sup>M<sub>1</sub></sup>={vc1,vc2}

       Atacante<sup>M<sub>1</sub></sup>={vc6,vc10}

       Lateral Esquerdo<sup>M<sub>1</sub></sup>={vc8}

       Canhoto<sup>M<sub>1</sub></sup>={vc8,vc10}

       Zagueiro<sup>M<sub>1</sub></sup>={vc9}

       Visitante<sup>M<sub>1</sub></sup>={vc1,vc2}

       Mandante<sup>M<sub>1</sub></sup>={vc1,vc2}

       Titular<sup>M<sub>1</sub></sup>={vc4,vc6,vc7,vc8,vc9,vc10}

       Reserva<sup>M<sub>1</sub></sup>={vc5}

       Artilheiro<sup>M<sub>1</sub></sup>={vc6,vc10}

       Marca<sup>M<sub>1</sub></sup>={vc6,vc7,vc8,vc9,vc10}

       Mãos<sup>M<sub>1</sub></sup>={vc4,vc5}

       Compatriotas<sup>M<sub>1</sub></sup>={(vc3,vc6),(vc7,vc8)}

       Assistir<sup>M<sub>1</sub></sup>={(vc6,vc8),(vc8,vc6)}

       Campeão<sup>M<sub>1</sub></sup>={(vc5,vc3),(vc6,vc3),(vc7,vc3),(vc8,vc3),(vc9,vc3)}
   
      Treina<sup>M<sub>1</sub></sup>={(vc3,vc4,vc5),(vc3,vc4,vc6),(vc3,vc4,vc7),(vc3,vc4,vc8),(vc3,vc4,vc9),(vc3,vc5,vc6),(vc3,vc5,vc7),       (vc3,vc5,vc8),(vc3,vc5,vc9),(vc3,vc6,vc7),(vc3,vc6,vc8),(vc3,vc6,vc9),(vc3,vc7,vc8),(vc3,vc7,vc9),(vc3,vc8,vc9)}
    
  ## 4.2 Exemplo de modelo que não satisfaz todas as fórmulas(M<sub>2</sub>)
  
  1. Universo de valores concretos
       
       A={vc1, vc2, vc3, vc4, vc5, vc6, vc7, vc8, vc9, vc10, vc11, vc12, vc13, vc14}
  
  2. Constantes
    
      "Real Madrid"<sup>M<sub>2</sub></sup>=vc1
    
      "Barcelona"<sup>M<sub>2</sub></sup>=vc2
    
       "Zidane"<sup>M<sub>2</sub></sup>=vc3

       "Courtois"<sup>M<sub>2</sub></sup>=vc4
    
       "Navas"<sup>M<sub>2</sub></sup>=vc5

       "Benzema"<sup>M<sub>2</sub></sup>=vc6

       "Casemiro"<sup>M<sub>2</sub></sup>=vc7

       "Marcelo"<sup>M<sub>2</sub></sup>=vc8

       "Sergio Ramos"<sup>M<sub>2</sub></sup>=vc9

       "Messi"<sup>M<sub>2</sub></sup>=vc10

       "Cartão Vermelho"<sup>M<sub>2</sub></sup>=vc11

       "Cartão Amarelo"<sup>M<sub>2</sub></sup>=vc12

       "Ninguém"<sup>M<sub>2</sub></sup>=vc13

       "Nenhuma"<sup>M<sub>2</sub></sup>=vc14

  3. Funções
    
       Capitão<sup>M<sub>2</sub></sup>(vc1)=vc10

       Capitão<sup>M<sub>2</sub></sup>(vc2)=vc9

       Capitão<sup>M<sub>2</sub></sup>(...)=vc13

       Punição<sup>M<sub>2</sub></sup>(vc4)=vc12   

       Punição<sup>M<sub>2</sub></sup>(vc5)=vc12

       Punição<sup>M<sub>2</sub></sup>(vc9)=vc11

       Punição<sup>M<sub>2</sub></sup>(vc10)=vc12

       Punição<sup>M<sub>2</sub></sup>(...)=vc14

       Jogam<sup>M<sub>2</sub></sup>(vc4,vc6)=vc11

       Jogam<sup>M<sub>2</sub></sup>(...,...)=vc14
   
   4. Predicados
    
       Goleiro<sup>M<sub>2</sub></sup>={vc4,vc5}

       Time Espanhol<sup>M<sub>2</sub></sup>={vc1,vc2}

       Atacante<sup>M<sub>2</sub></sup>={vc6,vc10}

       Lateral Esquerdo<sup>M<sub>2</sub></sup>={vc8}

       Canhoto<sup>M<sub>2</sub></sup>={vc8,vc10}

       Zagueiro<sup>M<sub>2</sub></sup>={}

       Visitante<sup>M<sub>2</sub></sup>={vc1,vc2}

       Mandante<sup>M<sub>2</sub></sup>={vc1,vc2}

       Titular<sup>M<sub>2</sub></sup>={vc4,vc6,vc7,vc8,vc9,vc10}

       Reserva<sup>M<sub>2</sub></sup>={}

       Artilheiro<sup>M<sub>2</sub></sup>={vc6,vc10}

       Marca<sup>M<sub>2</sub></sup>={vc6,vc7,vc8,vc9,vc10}

       Mãos<sup>M<sub>2</sub></sup>={}

       Compatriotas<sup>M<sub>2</sub></sup>={(vc3,vc6),(vc7,vc8)}

       Assistir<sup>M<sub>2</sub></sup>={(vc6,vc8),(vc8,vc6)}

       Campeão<sup>M<sub>2</sub></sup>={(vc5,vc3),(vc6,vc3),(vc7,vc3),(vc8,vc3),(vc9,vc3)}
    
      Treina<sup>M<sub>2</sub></sup>={ (vc3,X,Y) | X,Y ∈ {vc4,vc5,vc6,vc7,vc8,vc9} ∧ X≠Y }
